#include "arduino.h"
#include <avr/pgmspace.h>
#include "ILI948x.h"
#include "HSV.h"
#include "Leaves.h"
#include "SmallChars.h"

// nHeight = 88, Arial Monospaced MT
// some letters excluded, eg Q, Z...
// ~5.5k data
// upper and lower char data
const byte PROGMEM rowDataUpper[] =
{
  // '0'
  BACK(46) + END,
  BACK(46) + END,
  BACK(19), FORE( 9) + END,
  BACK(16), FORE(14) + END,
  BACK(14), FORE(18) + END,
  BACK(13), FORE(20) + END,
  BACK(12), FORE(22) + END,
  BACK(11), FORE( 9), BACK( 6), FORE( 9) + END,
  BACK(10), FORE( 8), BACK(10), FORE( 8) + END,
  BACK( 9), FORE( 8), BACK(12), FORE( 8) + END,
  BACK( 9), FORE( 7), BACK(14), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  // '1'
  BACK(46) + END,
  BACK(46) + END,
  BACK(24), FORE( 5) + END,
  BACK(24), FORE( 5) + END,
  BACK(23), FORE( 6) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(21), FORE( 8) + END,
  BACK(20), FORE( 9) + END,
  BACK(19), FORE(10) + END,
  BACK(17), FORE(12) + END,
  BACK(16), FORE(13) + END,
  BACK(15), FORE(14) + END,
  BACK(13), FORE(16) + END,
  BACK(12), FORE(17) + END,
  BACK(10), FORE(11), BACK( 1), FORE( 7) + END,
  BACK( 9), FORE(11), BACK( 2), FORE( 7) + END,
  BACK( 9), FORE( 9), BACK( 4), FORE( 7) + END,
  BACK( 9), FORE( 8), BACK( 5), FORE( 7) + END,
  BACK( 9), FORE( 6), BACK( 7), FORE( 7) + END,
  BACK( 9), FORE( 4), BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 2), BACK(11), FORE( 7) + END,
  BACK( 9), FORE( 1), BACK(12), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  // '2'
  BACK(46) + END,
  BACK(46) + END,
  BACK(18), FORE(10) + END,
  BACK(14), FORE(17) + END,
  BACK(12), FORE(21) + END,
  BACK(11), FORE(23) + END,
  BACK(10), FORE(25) + END,
  BACK( 9), FORE(10), BACK( 7), FORE(10) + END,
  BACK( 8), FORE( 9), BACK(11), FORE( 9) + END,
  BACK( 7), FORE( 9), BACK(14), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(18), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 6) + END,
  BACK( 6), FORE( 6), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 7), FORE( 5), BACK(21), FORE( 7) + END,
  BACK(33), FORE( 7) + END,
  BACK(33), FORE( 7) + END,
  BACK(32), FORE( 8) + END,
  BACK(32), FORE( 8) + END,
  BACK(31), FORE( 8) + END,
  BACK(31), FORE( 8) + END,
  BACK(30), FORE( 8) + END,
  BACK(29), FORE( 9) + END,
  BACK(29), FORE( 8) + END,
  BACK(28), FORE( 9) + END,
  BACK(27), FORE( 9) + END,
  BACK(26), FORE( 9) + END,
  // '3'
  BACK(46) + END,
  BACK(46) + END,
  BACK(17), FORE( 9) + END,
  BACK(14), FORE(15) + END,
  BACK(12), FORE(19) + END,
  BACK(11), FORE(22) + END,
  BACK(10), FORE(24) + END,
  BACK( 9), FORE(10), BACK( 6), FORE(10) + END,
  BACK( 8), FORE( 9), BACK(10), FORE( 9) + END,
  BACK( 8), FORE( 8), BACK(13), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(16), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 7) + END,
  BACK(10), FORE( 2), BACK(19), FORE( 7) + END,
  BACK(31), FORE( 7) + END,
  BACK(31), FORE( 7) + END,
  BACK(30), FORE( 8) + END,
  BACK(30), FORE( 7) + END,
  BACK(29), FORE( 8) + END,
  BACK(28), FORE( 8) + END,
  BACK(27), FORE( 9) + END,
  BACK(24), FORE(11) + END,
  BACK(19), FORE(15) + END,
  BACK(19), FORE(13) + END,
  BACK(19), FORE(12) + END,
  BACK(18), FORE(16) + END,
  BACK(18), FORE(18) + END,
  // '4'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(29), FORE( 6) + END,
  BACK(28), FORE( 7) + END,
  BACK(27), FORE( 8) + END,
  BACK(27), FORE( 8) + END,
  BACK(26), FORE( 9) + END,
  BACK(25), FORE(10) + END,
  BACK(25), FORE(10) + END,
  BACK(24), FORE(11) + END,
  BACK(23), FORE(12) + END,
  BACK(22), FORE(13) + END,
  BACK(22), FORE(13) + END,
  BACK(21), FORE( 6), BACK( 1), FORE( 7) + END,
  BACK(20), FORE( 6), BACK( 2), FORE( 7) + END,
  BACK(20), FORE( 6), BACK( 2), FORE( 7) + END,
  BACK(19), FORE( 6), BACK( 3), FORE( 7) + END,
  BACK(18), FORE( 6), BACK( 4), FORE( 7) + END,
  BACK(17), FORE( 7), BACK( 4), FORE( 7) + END,
  BACK(17), FORE( 6), BACK( 5), FORE( 7) + END,
  BACK(16), FORE( 6), BACK( 6), FORE( 7) + END,
  BACK(15), FORE( 7), BACK( 6), FORE( 7) + END,
  BACK(15), FORE( 6), BACK( 7), FORE( 7) + END,
  BACK(14), FORE( 6), BACK( 8), FORE( 7) + END,
  BACK(13), FORE( 7), BACK( 8), FORE( 7) + END,
  BACK(13), FORE( 6), BACK( 9), FORE( 7) + END,
  BACK(12), FORE( 6), BACK(10), FORE( 7) + END,
  BACK(11), FORE( 6), BACK(11), FORE( 7) + END,
  BACK(10), FORE( 7), BACK(11), FORE( 7) + END,
  // '5'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(11), FORE(27) + END,
  BACK(11), FORE(27) + END,
  BACK(11), FORE(27) + END,
  BACK(11), FORE(27) + END,
  BACK(11), FORE(27) + END,
  BACK(10), FORE(28) + END,
  BACK(10), FORE( 7) + END,
  BACK(10), FORE( 7) + END,
  BACK(10), FORE( 6) + END,
  BACK(10), FORE( 6) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 6) + END,
  BACK( 9), FORE( 6) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 6), BACK( 6), FORE( 8) + END,
  BACK( 8), FORE( 6), BACK( 3), FORE(14) + END,
  BACK( 8), FORE( 6), BACK( 1), FORE(18) + END,
  BACK( 7), FORE(28) + END,
  BACK( 7), FORE(29) + END,
  BACK( 7), FORE(12), BACK( 7), FORE(11) + END,
  BACK( 7), FORE(10), BACK(11), FORE(10) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 6), FORE( 8), BACK(17), FORE( 8) + END,
  // '6'
  BACK(46) + END,
  BACK(46) + END,
  BACK(19), FORE( 9) + END,
  BACK(16), FORE(15) + END,
  BACK(14), FORE(19) + END,
  BACK(13), FORE(21) + END,
  BACK(12), FORE(24) + END,
  BACK(11), FORE( 9), BACK( 7), FORE( 9) + END,
  BACK(10), FORE( 8), BACK(10), FORE( 9) + END,
  BACK( 9), FORE( 8), BACK(13), FORE( 8) + END,
  BACK( 9), FORE( 7), BACK(14), FORE( 8) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(17), FORE( 7) + END,
  BACK( 8), FORE( 6), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 6), BACK(19), FORE( 7) + END,
  BACK( 7), FORE( 6), BACK(19), FORE( 2) + END,
  BACK( 7), FORE( 6) + END,
  BACK( 6), FORE( 6) + END,
  BACK( 6), FORE( 6) + END,
  BACK( 6), FORE( 6) + END,
  BACK( 6), FORE( 6) + END,
  BACK( 6), FORE( 5) + END,
  BACK( 5), FORE( 6), BACK( 9), FORE( 9) + END,
  BACK( 5), FORE( 6), BACK( 6), FORE(14) + END,
  BACK( 5), FORE( 6), BACK( 5), FORE(17) + END,
  BACK( 5), FORE( 6), BACK( 3), FORE(21) + END,
  BACK( 5), FORE( 6), BACK( 2), FORE(23) + END,
  BACK( 5), FORE( 6), BACK( 1), FORE( 8), BACK( 7), FORE(10) + END,
  BACK( 5), FORE(13), BACK(11), FORE( 9) + END,
  BACK( 5), FORE(11), BACK(14), FORE( 8) + END,
  // '7'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE(35) + END,
  BACK( 6), FORE(35) + END,
  BACK( 6), FORE(35) + END,
  BACK( 6), FORE(35) + END,
  BACK( 6), FORE(35) + END,
  BACK( 6), FORE(35) + END,
  BACK(32), FORE( 8) + END,
  BACK(31), FORE( 8) + END,
  BACK(31), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(29), FORE( 8) + END,
  BACK(28), FORE( 8) + END,
  BACK(28), FORE( 7) + END,
  BACK(27), FORE( 8) + END,
  BACK(26), FORE( 8) + END,
  BACK(26), FORE( 7) + END,
  BACK(25), FORE( 8) + END,
  BACK(24), FORE( 8) + END,
  BACK(24), FORE( 7) + END,
  BACK(23), FORE( 8) + END,
  BACK(23), FORE( 7) + END,
  BACK(22), FORE( 8) + END,
  BACK(22), FORE( 7) + END,
  BACK(21), FORE( 8) + END,
  BACK(21), FORE( 7) + END,
  BACK(20), FORE( 8) + END,
  // '8'
  BACK(46) + END,
  BACK(46) + END,
  BACK(18), FORE(10) + END,
  BACK(15), FORE(15) + END,
  BACK(13), FORE(19) + END,
  BACK(12), FORE(22) + END,
  BACK(11), FORE(24) + END,
  BACK(10), FORE(10), BACK( 6), FORE(10) + END,
  BACK( 9), FORE( 9), BACK(10), FORE( 9) + END,
  BACK( 9), FORE( 8), BACK(12), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 8) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 9), FORE( 8), BACK(12), FORE( 8) + END,
  BACK( 9), FORE( 9), BACK(10), FORE( 9) + END,
  BACK(10), FORE(10), BACK( 6), FORE(10) + END,
  BACK(11), FORE(23) + END,
  BACK(13), FORE(20) + END,
  BACK(15), FORE(16) + END,
  BACK(12), FORE(21) + END,
  BACK(10), FORE(25) + END,
  // '9'
  BACK(46) + END,
  BACK(46) + END,
  BACK(17), FORE( 9) + END,
  BACK(15), FORE(14) + END,
  BACK(13), FORE(18) + END,
  BACK(11), FORE(21) + END,
  BACK(10), FORE(23) + END,
  BACK( 9), FORE(11), BACK( 6), FORE( 8) + END,
  BACK( 9), FORE( 9), BACK(10), FORE( 7) + END,
  BACK( 8), FORE( 8), BACK(13), FORE( 7) + END,
  BACK( 7), FORE( 9), BACK(14), FORE( 6) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 6) + END,
  BACK( 6), FORE( 8), BACK(17), FORE( 6) + END,
  BACK( 6), FORE( 8), BACK(18), FORE( 6) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 6) + END,
  BACK( 5), FORE( 8), BACK(19), FORE( 7) + END,
  BACK( 5), FORE( 8), BACK(20), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 8), BACK(17), FORE( 9) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 9) + END,
  BACK( 7), FORE( 8), BACK(15), FORE(10) + END,
  // ':' (manually edited, dots made wider)
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'A'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(18), FORE( 8) + END,
  BACK(18), FORE( 9) + END,
  BACK(17), FORE(10) + END,
  BACK(17), FORE(10) + END,
  BACK(17), FORE(11) + END,
  BACK(16), FORE(12) + END,
  BACK(16), FORE(12) + END,
  BACK(16), FORE(13) + END,
  BACK(15), FORE(14) + END,
  BACK(15), FORE( 7), BACK( 1), FORE( 7) + END,
  BACK(15), FORE( 6), BACK( 2), FORE( 7) + END,
  BACK(14), FORE( 7), BACK( 2), FORE( 7) + END,
  BACK(14), FORE( 7), BACK( 3), FORE( 7) + END,
  BACK(14), FORE( 6), BACK( 4), FORE( 7) + END,
  BACK(13), FORE( 7), BACK( 4), FORE( 7) + END,
  BACK(13), FORE( 7), BACK( 5), FORE( 7) + END,
  BACK(13), FORE( 6), BACK( 6), FORE( 7) + END,
  BACK(12), FORE( 7), BACK( 6), FORE( 7) + END,
  BACK(12), FORE( 7), BACK( 7), FORE( 7) + END,
  BACK(12), FORE( 7), BACK( 7), FORE( 7) + END,
  BACK(12), FORE( 6), BACK( 8), FORE( 7) + END,
  BACK(11), FORE( 7), BACK( 9), FORE( 7) + END,
  BACK(11), FORE( 7), BACK( 9), FORE( 7) + END,
  BACK(11), FORE( 6), BACK(10), FORE( 7) + END,
  BACK(10), FORE( 7), BACK(11), FORE( 7) + END,
  BACK(10), FORE( 7), BACK(11), FORE( 7) + END,
  BACK(10), FORE( 6), BACK(12), FORE( 7) + END,
  // 'B'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE(22) + END,
  BACK( 6), FORE(25) + END,
  BACK( 6), FORE(27) + END,
  BACK( 6), FORE(29) + END,
  BACK( 6), FORE(30) + END,
  BACK( 6), FORE(31) + END,
  BACK( 6), FORE( 7), BACK(14), FORE(11) + END,
  BACK( 6), FORE( 7), BACK(16), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 6) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(16), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(14), FORE( 9) + END,
  BACK( 6), FORE(29) + END,
  BACK( 6), FORE(28) + END,
  BACK( 6), FORE(26) + END,
  BACK( 6), FORE(29) + END,
  // 'C'
  BACK(46) + END,
  BACK(46) + END,
  BACK(19), FORE(10) + END,
  BACK(16), FORE(16) + END,
  BACK(14), FORE(20) + END,
  BACK(12), FORE(24) + END,
  BACK(11), FORE(26) + END,
  BACK(10), FORE(28) + END,
  BACK(10), FORE(10), BACK( 8), FORE(11) + END,
  BACK( 9), FORE( 9), BACK(12), FORE(10) + END,
  BACK( 8), FORE( 9), BACK(15), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(17), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(18), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 3) + END,
  BACK( 5), FORE( 8) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  // 'D'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE(17) + END,
  BACK( 6), FORE(22) + END,
  BACK( 6), FORE(24) + END,
  BACK( 6), FORE(26) + END,
  BACK( 6), FORE(28) + END,
  BACK( 6), FORE(29) + END,
  BACK( 6), FORE( 7), BACK( 9), FORE(14) + END,
  BACK( 6), FORE( 7), BACK(13), FORE(11) + END,
  BACK( 6), FORE( 7), BACK(15), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(16), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(17), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  // 'E'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE(30) + END,
  BACK( 8), FORE(30) + END,
  BACK( 8), FORE(30) + END,
  BACK( 8), FORE(30) + END,
  // 'F'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 8), FORE(36) + END,
  BACK( 8), FORE(36) + END,
  BACK( 8), FORE(36) + END,
  BACK( 8), FORE(36) + END,
  BACK( 8), FORE(36) + END,
  BACK( 8), FORE(36) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  // 'G'
  BACK(46) + END,
  BACK(46) + END,
  BACK(19), FORE(10) + END,
  BACK(16), FORE(16) + END,
  BACK(14), FORE(19) + END,
  BACK(13), FORE(22) + END,
  BACK(11), FORE(25) + END,
  BACK(10), FORE(27) + END,
  BACK(10), FORE(10), BACK( 7), FORE(11) + END,
  BACK( 9), FORE( 8), BACK(12), FORE( 9) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 9) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 2) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(12), FORE(18) + END,
  // 'H'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE(33) + END,
  BACK( 6), FORE(33) + END,
  BACK( 6), FORE(33) + END,
  BACK( 6), FORE(33) + END,
  BACK( 6), FORE(33) + END,
  // 'I'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  // 'J'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  /* 'K'
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE( 7), BACK(21), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(17), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(16), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(16), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(15), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(14), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(13), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(12), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(11), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(11), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(10), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 9), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 8), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 7), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 6), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 5), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 5), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 4), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 3), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 2), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK( 1), FORE(10) + END,
  BACK( 6), FORE(18) + END,
  BACK( 6), FORE(19) + END,*/
  // 'L'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  // 'M'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE( 8), BACK(18), FORE( 8) + END,
  BACK( 6), FORE( 8), BACK(17), FORE( 9) + END,
  BACK( 6), FORE( 9), BACK(16), FORE( 9) + END,
  BACK( 6), FORE( 9), BACK(15), FORE(10) + END,
  BACK( 6), FORE(10), BACK(14), FORE(10) + END,
  BACK( 6), FORE(10), BACK(14), FORE(10) + END,
  BACK( 6), FORE(11), BACK(12), FORE(11) + END,
  BACK( 6), FORE(11), BACK(12), FORE(11) + END,
  BACK( 6), FORE(12), BACK(10), FORE(12) + END,
  BACK( 6), FORE(12), BACK(10), FORE(12) + END,
  BACK( 6), FORE(12), BACK( 9), FORE(13) + END,
  BACK( 6), FORE(13), BACK( 8), FORE(13) + END,
  BACK( 6), FORE(13), BACK( 8), FORE( 5), BACK( 1), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 1), FORE( 6), BACK( 6), FORE( 6), BACK( 1), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 1), FORE( 6), BACK( 6), FORE( 5), BACK( 2), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 2), FORE( 6), BACK( 4), FORE( 6), BACK( 2), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 2), FORE( 6), BACK( 4), FORE( 5), BACK( 3), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 3), FORE( 5), BACK( 3), FORE( 6), BACK( 3), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 3), FORE( 6), BACK( 2), FORE( 6), BACK( 3), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 3), FORE( 6), BACK( 2), FORE( 5), BACK( 4), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 4), FORE(12), BACK( 4), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 4), FORE(11), BACK( 5), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 5), FORE(10), BACK( 5), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 5), FORE(10), BACK( 5), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 5), FORE( 9), BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 6), FORE( 8), BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 6), FORE( 7), BACK( 7), FORE( 7) + END,
  // 'N'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE( 8), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 9), BACK(18), FORE( 7) + END,
  BACK( 6), FORE( 9), BACK(18), FORE( 7) + END,
  BACK( 6), FORE(10), BACK(17), FORE( 7) + END,
  BACK( 6), FORE(10), BACK(17), FORE( 7) + END,
  BACK( 6), FORE(11), BACK(16), FORE( 7) + END,
  BACK( 6), FORE(11), BACK(16), FORE( 7) + END,
  BACK( 6), FORE(12), BACK(15), FORE( 7) + END,
  BACK( 6), FORE(12), BACK(15), FORE( 7) + END,
  BACK( 6), FORE(13), BACK(14), FORE( 7) + END,
  BACK( 6), FORE(13), BACK(14), FORE( 7) + END,
  BACK( 6), FORE(14), BACK(13), FORE( 7) + END,
  BACK( 6), FORE(14), BACK(13), FORE( 7) + END,
  BACK( 6), FORE(15), BACK(12), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 1), FORE( 7), BACK(12), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 1), FORE( 8), BACK(11), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 2), FORE( 7), BACK(11), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 2), FORE( 8), BACK(10), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 3), FORE( 7), BACK(10), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 3), FORE( 8), BACK( 9), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 4), FORE( 7), BACK( 9), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 4), FORE( 8), BACK( 8), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 5), FORE( 7), BACK( 8), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 5), FORE( 8), BACK( 7), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 6), FORE( 7), BACK( 7), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 6), FORE( 8), BACK( 6), FORE( 7) + END,
  // 'O'
  BACK(46) + END,
  BACK(46) + END,
  BACK(18), FORE( 9) + END,
  BACK(15), FORE(15) + END,
  BACK(13), FORE(19) + END,
  BACK(12), FORE(22) + END,
  BACK(11), FORE(24) + END,
  BACK(10), FORE(26) + END,
  BACK( 9), FORE(10), BACK( 7), FORE(10) + END,
  BACK( 8), FORE( 9), BACK(11), FORE( 9) + END,
  BACK( 8), FORE( 8), BACK(13), FORE( 9) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(17), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 6), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  // 'P'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE(23) + END,
  BACK( 6), FORE(27) + END,
  BACK( 6), FORE(29) + END,
  BACK( 6), FORE(31) + END,
  BACK( 6), FORE(32) + END,
  BACK( 6), FORE(33) + END,
  BACK( 6), FORE( 7), BACK(16), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(17), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(14), FORE(12) + END,
  BACK( 6), FORE(32) + END,
  /* 'Q'
  BACK(46) + END,
  BACK(18), FORE( 9) + END,
  BACK(15), FORE(15) + END,
  BACK(13), FORE(19) + END,
  BACK(12), FORE(22) + END,
  BACK(11), FORE(24) + END,
  BACK(10), FORE(26) + END,
  BACK( 9), FORE(10), BACK( 7), FORE(10) + END,
  BACK( 8), FORE( 9), BACK(11), FORE( 9) + END,
  BACK( 8), FORE( 8), BACK(13), FORE( 9) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(17), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 6), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END, */
  // 'R'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE(24) + END,
  BACK( 6), FORE(28) + END,
  BACK( 6), FORE(30) + END,
  BACK( 6), FORE(31) + END,
  BACK( 6), FORE(32) + END,
  BACK( 6), FORE( 7), BACK(15), FORE(11) + END,
  BACK( 6), FORE( 7), BACK(17), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(17), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(15), FORE(11) + END,
  BACK( 6), FORE(32) + END,
  BACK( 6), FORE(31) + END,
  BACK( 6), FORE(29) + END,
  // 'S'
  BACK(46) + END,
  BACK(46) + END,
  BACK(18), FORE(11) + END,
  BACK(15), FORE(17) + END,
  BACK(13), FORE(21) + END,
  BACK(11), FORE(25) + END,
  BACK(10), FORE(27) + END,
  BACK( 9), FORE(29) + END,
  BACK( 9), FORE(10), BACK( 9), FORE(10) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 9) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 9) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 6) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 8) + END,
  BACK( 6), FORE( 8) + END,
  BACK( 7), FORE( 8) + END,
  BACK( 7), FORE(10) + END,
  BACK( 7), FORE(12) + END,
  BACK( 8), FORE(14) + END,
  BACK( 9), FORE(17) + END,
  BACK( 9), FORE(20) + END,
  BACK(10), FORE(22) + END,
  BACK(12), FORE(22) + END,
  BACK(14), FORE(22) + END,
  // 'T'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 3), FORE(39) + END,
  BACK( 3), FORE(39) + END,
  BACK( 3), FORE(39) + END,
  BACK( 3), FORE(39) + END,
  BACK( 3), FORE(39) + END,
  BACK( 3), FORE(39) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  // 'U'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  // 'V'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 1), FORE( 8), BACK(28), FORE( 8) + END,
  BACK( 2), FORE( 7), BACK(28), FORE( 7) + END,
  BACK( 2), FORE( 8), BACK(27), FORE( 7) + END,
  BACK( 2), FORE( 8), BACK(26), FORE( 7) + END,
  BACK( 3), FORE( 7), BACK(26), FORE( 7) + END,
  BACK( 3), FORE( 8), BACK(25), FORE( 7) + END,
  BACK( 3), FORE( 8), BACK(24), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(24), FORE( 7) + END,
  BACK( 4), FORE( 8), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 8), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 8), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 8), BACK(21), FORE( 6) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(19), FORE( 6) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(17), FORE( 6) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 8), FORE( 8), BACK(15), FORE( 6) + END,
  BACK( 9), FORE( 7), BACK(14), FORE( 7) + END,
  BACK( 9), FORE( 7), BACK(14), FORE( 7) + END,
  BACK( 9), FORE( 8), BACK(13), FORE( 6) + END,
  BACK(10), FORE( 7), BACK(12), FORE( 7) + END,
  BACK(10), FORE( 7), BACK(12), FORE( 7) + END,
  // 'W'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 1), FORE( 7), BACK(31), FORE( 6) + END,
  BACK( 1), FORE( 7), BACK(31), FORE( 6) + END,
  BACK( 1), FORE( 7), BACK(31), FORE( 6) + END,
  BACK( 1), FORE( 7), BACK(30), FORE( 7) + END,
  BACK( 1), FORE( 7), BACK(30), FORE( 7) + END,
  BACK( 1), FORE( 7), BACK(30), FORE( 6) + END,
  BACK( 1), FORE( 7), BACK(30), FORE( 6) + END,
  BACK( 2), FORE( 7), BACK(29), FORE( 6) + END,
  BACK( 2), FORE( 7), BACK(29), FORE( 6) + END,
  BACK( 2), FORE( 7), BACK(29), FORE( 6) + END,
  BACK( 2), FORE( 7), BACK(29), FORE( 6) + END,
  BACK( 2), FORE( 7), BACK(29), FORE( 6) + END,
  BACK( 2), FORE( 7), BACK(28), FORE( 7) + END,
  BACK( 2), FORE( 7), BACK(28), FORE( 6) + END,
  BACK( 2), FORE( 7), BACK(28), FORE( 6) + END,
  BACK( 3), FORE( 6), BACK(28), FORE( 6) + END,
  BACK( 3), FORE( 6), BACK(28), FORE( 6) + END,
  BACK( 3), FORE( 7), BACK(27), FORE( 6) + END,
  BACK( 3), FORE( 7), BACK(11), FORE( 4), BACK(12), FORE( 6) + END,
  BACK( 3), FORE( 7), BACK(11), FORE( 4), BACK(12), FORE( 6) + END,
  BACK( 3), FORE( 7), BACK(11), FORE( 5), BACK(11), FORE( 6) + END,
  BACK( 3), FORE( 7), BACK(10), FORE( 6), BACK(10), FORE( 6) + END,
  BACK( 3), FORE( 7), BACK(10), FORE( 7), BACK( 9), FORE( 6) + END,
  BACK( 4), FORE( 6), BACK( 9), FORE( 8), BACK( 9), FORE( 6) + END,
  BACK( 4), FORE( 6), BACK( 9), FORE( 8), BACK( 9), FORE( 6) + END,
  BACK( 4), FORE( 6), BACK( 9), FORE( 9), BACK( 8), FORE( 6) + END,
  BACK( 4), FORE( 7), BACK( 7), FORE(10), BACK( 8), FORE( 6) + END,
  /* 'X'
  BACK(46) + END,
  BACK(46) + END,
  BACK( 4), FORE( 9), BACK(21), FORE( 9) + END,
  BACK( 5), FORE( 8), BACK(21), FORE( 8) + END,
  BACK( 5), FORE( 9), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 8), BACK(19), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(17), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(17), FORE( 7) + END,
  BACK( 8), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 9), FORE( 8), BACK(13), FORE( 7) + END,
  BACK(10), FORE( 8), BACK(11), FORE( 8) + END,
  BACK(10), FORE( 8), BACK(11), FORE( 7) + END,
  BACK(11), FORE( 8), BACK( 9), FORE( 7) + END,
  BACK(11), FORE( 8), BACK( 8), FORE( 8) + END,
  BACK(12), FORE( 8), BACK( 7), FORE( 7) + END,
  BACK(13), FORE( 7), BACK( 6), FORE( 8) + END,
  BACK(13), FORE( 8), BACK( 5), FORE( 7) + END,
  BACK(14), FORE( 7), BACK( 4), FORE( 7) + END,
  BACK(14), FORE( 8), BACK( 2), FORE( 8) + END,
  BACK(15), FORE( 7), BACK( 2), FORE( 7) + END,
  BACK(16), FORE(14) + END,
  BACK(16), FORE(14) + END,
  BACK(17), FORE(12) + END,
  BACK(17), FORE(12) + END,
  BACK(18), FORE(10) + END,
  BACK(19), FORE( 8) + END,
  BACK(19), FORE( 8) + END,
  BACK(19), FORE( 9) + END, */
  // 'Y'
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK( 0), FORE( 9), BACK(27), FORE( 9) + END,
  BACK( 1), FORE( 8), BACK(27), FORE( 8) + END,
  BACK( 2), FORE( 8), BACK(25), FORE( 8) + END,
  BACK( 2), FORE( 9), BACK(24), FORE( 8) + END,
  BACK( 3), FORE( 8), BACK(23), FORE( 8) + END,
  BACK( 4), FORE( 8), BACK(21), FORE( 8) + END,
  BACK( 4), FORE( 8), BACK(21), FORE( 8) + END,
  BACK( 5), FORE( 8), BACK(19), FORE( 8) + END,
  BACK( 5), FORE( 9), BACK(18), FORE( 8) + END,
  BACK( 6), FORE( 8), BACK(17), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(13), FORE( 8) + END,
  BACK( 8), FORE( 9), BACK(11), FORE( 9) + END,
  BACK( 9), FORE( 8), BACK(11), FORE( 8) + END,
  BACK(10), FORE( 8), BACK( 9), FORE( 8) + END,
  BACK(10), FORE( 8), BACK( 9), FORE( 8) + END,
  BACK(11), FORE( 8), BACK( 7), FORE( 8) + END,
  BACK(11), FORE( 8), BACK( 7), FORE( 8) + END,
  BACK(12), FORE( 8), BACK( 5), FORE( 8) + END,
  BACK(13), FORE( 8), BACK( 4), FORE( 7) + END,
  BACK(13), FORE( 8), BACK( 3), FORE( 8) + END,
  BACK(14), FORE( 8), BACK( 2), FORE( 7) + END,
  BACK(14), FORE( 8), BACK( 1), FORE( 8) + END,
  BACK(15), FORE(15) + END,
  BACK(16), FORE(13) + END,
  BACK(16), FORE(13) + END,
  /* 'Z'
  BACK(46) + END,
  BACK(46) + END,
  BACK( 6), FORE(34) + END,
  BACK( 6), FORE(34) + END,
  BACK( 6), FORE(34) + END,
  BACK( 6), FORE(34) + END,
  BACK( 6), FORE(34) + END,
  BACK( 6), FORE(34) + END,
  BACK(32), FORE( 8) + END,
  BACK(31), FORE( 8) + END,
  BACK(30), FORE( 9) + END,
  BACK(29), FORE( 9) + END,
  BACK(29), FORE( 8) + END,
  BACK(28), FORE( 9) + END,
  BACK(27), FORE( 9) + END,
  BACK(27), FORE( 8) + END,
  BACK(26), FORE( 8) + END,
  BACK(25), FORE( 9) + END,
  BACK(25), FORE( 8) + END,
  BACK(24), FORE( 8) + END,
  BACK(23), FORE( 9) + END,
  BACK(23), FORE( 8) + END,
  BACK(22), FORE( 8) + END,
  BACK(21), FORE( 9) + END,
  BACK(21), FORE( 8) + END,
  BACK(20), FORE( 8) + END,
  BACK(19), FORE( 9) + END,
  BACK(19), FORE( 8) + END,
  BACK(18), FORE( 8) + END, */
};

const byte PROGMEM rowDataLower[] =
{
  // '0'
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 6) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 9), FORE( 7), BACK(14), FORE( 7) + END,
  BACK( 9), FORE( 8), BACK(12), FORE( 8) + END,
  BACK(10), FORE( 8), BACK(10), FORE( 8) + END,
  BACK(11), FORE( 9), BACK( 6), FORE( 9) + END,
  BACK(11), FORE(23) + END,
  BACK(13), FORE(20) + END,
  BACK(14), FORE(18) + END,
  BACK(16), FORE(14) + END,
  BACK(18), FORE(10) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '1'
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(22), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '2'
  BACK(25), FORE( 9) + END,
  BACK(24), FORE(10) + END,
  BACK(23), FORE(10) + END,
  BACK(22), FORE(10) + END,
  BACK(20), FORE(11) + END,
  BACK(19), FORE(11) + END,
  BACK(18), FORE(10) + END,
  BACK(17), FORE(10) + END,
  BACK(16), FORE(10) + END,
  BACK(14), FORE(11) + END,
  BACK(13), FORE(11) + END,
  BACK(12), FORE(11) + END,
  BACK(11), FORE(11) + END,
  BACK(10), FORE(10) + END,
  BACK( 9), FORE(10) + END,
  BACK( 9), FORE( 9) + END,
  BACK( 8), FORE( 9) + END,
  BACK( 7), FORE( 9) + END,
  BACK( 7), FORE( 8) + END,
  BACK( 6), FORE( 8) + END,
  BACK( 5), FORE( 9) + END,
  BACK( 5), FORE(35) + END,
  BACK( 5), FORE(35) + END,
  BACK( 4), FORE(36) + END,
  BACK( 4), FORE(36) + END,
  BACK( 4), FORE(36) + END,
  BACK( 4), FORE(36) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '3'
  BACK(18), FORE( 3), BACK( 3), FORE(13) + END,
  BACK(28), FORE(10) + END,
  BACK(29), FORE( 9) + END,
  BACK(31), FORE( 8) + END,
  BACK(31), FORE( 9) + END,
  BACK(32), FORE( 8) + END,
  BACK(33), FORE( 7) + END,
  BACK(33), FORE( 8) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(11), FORE( 1), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(18), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 8), FORE( 9), BACK(11), FORE( 9) + END,
  BACK( 9), FORE(10), BACK( 7), FORE(10) + END,
  BACK(10), FORE(25) + END,
  BACK(11), FORE(23) + END,
  BACK(13), FORE(20) + END,
  BACK(15), FORE(16) + END,
  BACK(18), FORE( 9) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '4'
  BACK(10), FORE( 6), BACK(12), FORE( 7) + END,
  BACK( 9), FORE( 6), BACK(13), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(13), FORE( 7) + END,
  BACK( 8), FORE( 6), BACK(14), FORE( 7) + END,
  BACK( 7), FORE( 6), BACK(15), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(15), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 5), FORE( 6), BACK(17), FORE( 7) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(28), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '5'
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK(32), FORE( 8) + END,
  BACK(33), FORE( 7) + END,
  BACK(33), FORE( 7) + END,
  BACK(33), FORE( 8) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK(34), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 8), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 8), BACK(18), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(17), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 7), FORE( 9), BACK(13), FORE( 8) + END,
  BACK( 8), FORE( 9), BACK(11), FORE( 9) + END,
  BACK( 9), FORE(10), BACK( 7), FORE(10) + END,
  BACK(10), FORE(25) + END,
  BACK(11), FORE(23) + END,
  BACK(12), FORE(20) + END,
  BACK(14), FORE(16) + END,
  BACK(18), FORE( 9) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '6'
  BACK( 5), FORE(10), BACK(16), FORE( 8) + END,
  BACK( 5), FORE( 9), BACK(18), FORE( 7) + END,
  BACK( 5), FORE( 9), BACK(18), FORE( 8) + END,
  BACK( 5), FORE( 8), BACK(20), FORE( 7) + END,
  BACK( 5), FORE( 8), BACK(20), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 6), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 6), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 6), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 7), FORE( 6), BACK(20), FORE( 7) + END,
  BACK( 7), FORE( 6), BACK(20), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 8), FORE( 6), BACK(18), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(17), FORE( 7) + END,
  BACK( 9), FORE( 7), BACK(15), FORE( 8) + END,
  BACK( 9), FORE( 8), BACK(13), FORE( 8) + END,
  BACK(10), FORE( 8), BACK(10), FORE( 9) + END,
  BACK(11), FORE( 9), BACK( 7), FORE( 9) + END,
  BACK(12), FORE(23) + END,
  BACK(13), FORE(21) + END,
  BACK(15), FORE(18) + END,
  BACK(17), FORE(14) + END,
  BACK(20), FORE( 8) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '7'
  BACK(20), FORE( 7) + END,
  BACK(20), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(18), FORE( 8) + END,
  BACK(18), FORE( 7) + END,
  BACK(18), FORE( 7) + END,
  BACK(17), FORE( 8) + END,
  BACK(17), FORE( 7) + END,
  BACK(17), FORE( 7) + END,
  BACK(16), FORE( 8) + END,
  BACK(16), FORE( 7) + END,
  BACK(16), FORE( 7) + END,
  BACK(16), FORE( 7) + END,
  BACK(15), FORE( 7) + END,
  BACK(15), FORE( 7) + END,
  BACK(15), FORE( 7) + END,
  BACK(15), FORE( 7) + END,
  BACK(15), FORE( 7) + END,
  BACK(14), FORE( 7) + END,
  BACK(14), FORE( 7) + END,
  BACK(14), FORE( 7) + END,
  BACK(14), FORE( 7) + END,
  BACK(14), FORE( 7) + END,
  BACK(14), FORE( 7) + END,
  BACK(14), FORE( 7) + END,
  BACK(14), FORE( 6) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '8'
  BACK( 9), FORE(10), BACK( 7), FORE(10) + END,
  BACK( 8), FORE( 9), BACK(12), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 8) + END,
  BACK( 6), FORE( 8), BACK(18), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 5), FORE( 8), BACK(20), FORE( 8) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(19), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 8), FORE( 9), BACK(12), FORE( 9) + END,
  BACK( 9), FORE(11), BACK( 6), FORE(11) + END,
  BACK(10), FORE(26) + END,
  BACK(12), FORE(22) + END,
  BACK(13), FORE(20) + END,
  BACK(15), FORE(16) + END,
  BACK(18), FORE(10) + END,
  BACK(46) + END,
  BACK(46) + END,
  // '9'
  BACK( 8), FORE( 8), BACK(13), FORE(11) + END,
  BACK( 9), FORE( 8), BACK(11), FORE( 6), BACK( 1), FORE( 5) + END,
  BACK( 9), FORE(10), BACK( 7), FORE( 7), BACK( 2), FORE( 5) + END,
  BACK(10), FORE(23), BACK( 2), FORE( 5) + END,
  BACK(12), FORE(19), BACK( 4), FORE( 5) + END,
  BACK(13), FORE(17), BACK( 5), FORE( 5) + END,
  BACK(15), FORE(13), BACK( 6), FORE( 6) + END,
  BACK(18), FORE( 8), BACK( 8), FORE( 5) + END,
  BACK(34), FORE( 5) + END,
  BACK(34), FORE( 5) + END,
  BACK(34), FORE( 5) + END,
  BACK(34), FORE( 5) + END,
  BACK(33), FORE( 6) + END,
  BACK(33), FORE( 5) + END,
  BACK(12), FORE( 1), BACK(20), FORE( 5) + END,
  BACK( 7), FORE( 6), BACK(19), FORE( 6) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 5) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 6) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 5) + END,
  BACK( 8), FORE( 7), BACK(15), FORE( 6) + END,
  BACK( 8), FORE( 8), BACK(13), FORE( 6) + END,
  BACK( 9), FORE( 8), BACK(10), FORE( 8) + END,
  BACK( 9), FORE(10), BACK( 6), FORE( 9) + END,
  BACK(10), FORE(23) + END,
  BACK(11), FORE(21) + END,
  BACK(12), FORE(18) + END,
  BACK(14), FORE(15) + END,
  BACK(17), FORE( 9) + END,
  BACK(46) + END,
  BACK(46) + END,
  // ':' (manually edited, dots made wider)
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(19), FORE(10) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'A'
  BACK( 9), FORE( 7), BACK(13), FORE( 7) + END,
  BACK( 9), FORE( 7), BACK(13), FORE( 7) + END,
  BACK( 9), FORE( 7), BACK(13), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(15), FORE( 7) + END,
  BACK( 8), FORE( 7), BACK(15), FORE( 7) + END,
  BACK( 8), FORE(29) + END,
  BACK( 7), FORE(31) + END,
  BACK( 7), FORE(31) + END,
  BACK( 7), FORE(32) + END,
  BACK( 6), FORE(33) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 6), BACK(20), FORE( 8) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 8) + END,
  BACK( 3), FORE( 7), BACK(25), FORE( 7) + END,
  BACK( 3), FORE( 7), BACK(25), FORE( 7) + END,
  BACK( 3), FORE( 7), BACK(25), FORE( 8) + END,
  BACK( 2), FORE( 8), BACK(26), FORE( 7) + END,
  BACK( 2), FORE( 7), BACK(27), FORE( 7) + END,
  BACK( 2), FORE( 7), BACK(27), FORE( 8) + END,
  BACK( 1), FORE( 8), BACK(27), FORE( 8) + END,
  BACK( 1), FORE( 7), BACK(29), FORE( 7) + END,
  BACK( 1), FORE( 7), BACK(29), FORE( 8) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'B'
  BACK( 6), FORE(30) + END,
  BACK( 6), FORE(32) + END,
  BACK( 6), FORE( 7), BACK(14), FORE(12) + END,
  BACK( 6), FORE( 7), BACK(17), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(15), FORE(11) + END,
  BACK( 6), FORE(32) + END,
  BACK( 6), FORE(31) + END,
  BACK( 6), FORE(30) + END,
  BACK( 6), FORE(29) + END,
  BACK( 6), FORE(26) + END,
  BACK( 6), FORE(23) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'C'
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 4), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(24), FORE( 1) + END,
  BACK( 5), FORE( 7), BACK(24), FORE( 4) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(17), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 9), FORE( 9), BACK(11), FORE(10) + END,
  BACK( 9), FORE(11), BACK( 7), FORE(11) + END,
  BACK(10), FORE(27) + END,
  BACK(11), FORE(25) + END,
  BACK(12), FORE(22) + END,
  BACK(14), FORE(19) + END,
  BACK(16), FORE(15) + END,
  BACK(19), FORE( 9) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'D'
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(17), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(16), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(15), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(13), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(10), FORE(12) + END,
  BACK( 6), FORE(28) + END,
  BACK( 6), FORE(27) + END,
  BACK( 6), FORE(25) + END,
  BACK( 6), FORE(24) + END,
  BACK( 6), FORE(21) + END,
  BACK( 6), FORE(17) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'E'
  BACK( 8), FORE(30) + END,
  BACK( 8), FORE(30) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE(34) + END,
  BACK( 8), FORE(34) + END,
  BACK( 8), FORE(34) + END,
  BACK( 8), FORE(34) + END,
  BACK( 8), FORE(34) + END,
  BACK( 8), FORE(34) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'F'
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE(32) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK( 8), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'G'
  BACK( 4), FORE( 7), BACK(12), FORE(18) + END,
  BACK( 4), FORE( 7), BACK(12), FORE(18) + END,
  BACK( 4), FORE( 7), BACK(12), FORE(18) + END,
  BACK( 4), FORE( 7), BACK(12), FORE(18) + END,
  BACK( 4), FORE( 7), BACK(12), FORE(18) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 5), FORE( 6), BACK(23), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(18), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(15), FORE(10) + END,
  BACK( 9), FORE( 8), BACK(13), FORE(11) + END,
  BACK( 9), FORE(11), BACK( 7), FORE(13) + END,
  BACK(10), FORE(29) + END,
  BACK(11), FORE(26) + END,
  BACK(12), FORE(24) + END,
  BACK(14), FORE(20) + END,
  BACK(16), FORE(16) + END,
  BACK(19), FORE(10) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'H'
  BACK( 6), FORE(33) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'I'
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(10), FORE(25) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'J'
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK(30), FORE( 7) + END,
  BACK( 7), FORE( 2), BACK(21), FORE( 7) + END,
  BACK( 3), FORE( 6), BACK(21), FORE( 7) + END,
  BACK( 3), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 3), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 3), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 3), FORE( 8), BACK(18), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(17), FORE( 8) + END,
  BACK( 4), FORE( 8), BACK(16), FORE( 7) + END,
  BACK( 4), FORE( 9), BACK(14), FORE( 8) + END,
  BACK( 5), FORE( 9), BACK(11), FORE( 9) + END,
  BACK( 5), FORE(11), BACK( 7), FORE(11) + END,
  BACK( 6), FORE(27) + END,
  BACK( 7), FORE(25) + END,
  BACK( 8), FORE(23) + END,
  BACK(10), FORE(20) + END,
  BACK(11), FORE(17) + END,
  BACK(15), FORE(10) + END,
  BACK(46) + END,
  BACK(46) + END,
  /* 'K'
  BACK( 6), FORE(20) + END,
  BACK( 6), FORE(20) + END,
  BACK( 6), FORE(21) + END,
  BACK( 6), FORE(11), BACK( 2), FORE( 9) + END,
  BACK( 6), FORE(10), BACK( 4), FORE( 9) + END,
  BACK( 6), FORE( 9), BACK( 5), FORE( 9) + END,
  BACK( 6), FORE( 8), BACK( 7), FORE( 9) + END,
  BACK( 6), FORE( 8), BACK( 8), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK( 9), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(10), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(11), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(12), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(12), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(13), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(14), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(14), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(15), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(16), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(16), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(17), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(19), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(21), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(22), FORE(10) + END,
  BACK(46) + END,
  BACK(46) + END, */
  // 'L'
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE( 7) + END,
  BACK( 9), FORE(34) + END,
  BACK( 9), FORE(34) + END,
  BACK( 9), FORE(34) + END,
  BACK( 9), FORE(34) + END,
  BACK( 9), FORE(34) + END,
  BACK( 9), FORE(34) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'M'
  BACK( 6), FORE( 7), BACK( 7), FORE( 6), BACK( 7), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 7), FORE( 6), BACK( 7), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 7), FORE( 5), BACK( 8), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 8), FORE( 4), BACK( 8), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'N'
  BACK( 6), FORE( 7), BACK( 7), FORE( 7), BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 7), FORE( 8), BACK( 5), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 8), FORE( 7), BACK( 5), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 8), FORE( 8), BACK( 4), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 9), FORE( 7), BACK( 4), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 9), FORE( 8), BACK( 3), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 9), FORE( 8), BACK( 3), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(10), FORE( 8), BACK( 2), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(10), FORE( 8), BACK( 2), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(11), FORE( 8), BACK( 1), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(11), FORE( 8), BACK( 1), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(12), FORE( 7), BACK( 1), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(12), FORE(15) + END,
  BACK( 6), FORE( 7), BACK(13), FORE(14) + END,
  BACK( 6), FORE( 7), BACK(13), FORE(14) + END,
  BACK( 6), FORE( 7), BACK(14), FORE(13) + END,
  BACK( 6), FORE( 7), BACK(14), FORE(13) + END,
  BACK( 6), FORE( 7), BACK(15), FORE(12) + END,
  BACK( 6), FORE( 7), BACK(15), FORE(12) + END,
  BACK( 6), FORE( 7), BACK(16), FORE(11) + END,
  BACK( 6), FORE( 7), BACK(16), FORE(11) + END,
  BACK( 6), FORE( 7), BACK(17), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(17), FORE(10) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 8) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'O'
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 6), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 6), BACK(20), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(16), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 8), FORE( 9), BACK(11), FORE( 8) + END,
  BACK( 9), FORE(10), BACK( 7), FORE(10) + END,
  BACK( 9), FORE(26) + END,
  BACK(10), FORE(24) + END,
  BACK(11), FORE(22) + END,
  BACK(13), FORE(18) + END,
  BACK(15), FORE(15) + END,
  BACK(18), FORE( 9) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'P'
  BACK( 6), FORE(31) + END,
  BACK( 6), FORE(30) + END,
  BACK( 6), FORE(28) + END,
  BACK( 6), FORE(26) + END,
  BACK( 6), FORE(22) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK( 6), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  /* 'Q'
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(23), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 6), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(11), FORE( 3), BACK( 7), FORE( 7) + END,
  BACK( 5), FORE( 7), BACK(11), FORE( 4), BACK( 5), FORE( 7) + END,
  BACK( 6), FORE( 6), BACK(10), FORE( 7), BACK( 3), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 9), FORE( 8), BACK( 2), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK( 8), FORE(17) + END,
  BACK( 7), FORE( 7), BACK( 9), FORE(15) + END,
  BACK( 7), FORE( 7), BACK(11), FORE(12) + END,
  BACK( 7), FORE( 8), BACK(11), FORE(11) + END,
  BACK( 8), FORE( 8), BACK(11), FORE( 9) + END,
  BACK( 9), FORE(10), BACK( 7), FORE(11) + END,
  BACK( 9), FORE(29) + END,
  BACK(10), FORE(29) + END,
  BACK(11), FORE(30) + END,
  BACK(13), FORE(18), BACK( 2), FORE(10) + END,
  BACK(15), FORE(15), BACK( 4), FORE(10) + END,
  BACK(18), FORE( 9), BACK( 9), FORE( 8) + END,
  BACK(37), FORE( 6) + END, */
  // 'R'
  BACK( 6), FORE(27) + END,
  BACK( 6), FORE(24) + END,
  BACK( 6), FORE(21) + END,
  BACK( 6), FORE( 7), BACK( 6), FORE(10) + END,
  BACK( 6), FORE( 7), BACK( 7), FORE(10) + END,
  BACK( 6), FORE( 7), BACK( 9), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(10), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(11), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(11), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(12), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(13), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(13), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(14), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(15), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(15), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(16), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(17), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(17), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(18), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(20), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(21), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(22), FORE( 9) + END,
  BACK( 6), FORE( 7), BACK(23), FORE( 9) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'S'
  BACK(16), FORE(21) + END,
  BACK(20), FORE(18) + END,
  BACK(24), FORE(15) + END,
  BACK(27), FORE(13) + END,
  BACK(29), FORE(12) + END,
  BACK(31), FORE(10) + END,
  BACK(33), FORE( 8) + END,
  BACK(33), FORE( 9) + END,
  BACK(34), FORE( 8) + END,
  BACK(35), FORE( 7) + END,
  BACK(35), FORE( 7) + END,
  BACK( 8), FORE( 2), BACK(25), FORE( 7) + END,
  BACK( 3), FORE( 7), BACK(25), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(24), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(24), FORE( 7) + END,
  BACK( 4), FORE( 7), BACK(24), FORE( 7) + END,
  BACK( 4), FORE( 8), BACK(22), FORE( 7) + END,
  BACK( 5), FORE( 8), BACK(21), FORE( 7) + END,
  BACK( 5), FORE( 9), BACK(19), FORE( 8) + END,
  BACK( 6), FORE( 9), BACK(17), FORE( 8) + END,
  BACK( 6), FORE(11), BACK(14), FORE( 9) + END,
  BACK( 7), FORE(12), BACK( 9), FORE(11) + END,
  BACK( 8), FORE(30) + END,
  BACK( 9), FORE(28) + END,
  BACK(10), FORE(26) + END,
  BACK(12), FORE(23) + END,
  BACK(14), FORE(19) + END,
  BACK(18), FORE(11) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'T'
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'U'
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 7), BACK(19), FORE( 7) + END,
  BACK( 6), FORE( 8), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 7) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 8) + END,
  BACK( 8), FORE( 7), BACK(15), FORE( 7) + END,
  BACK( 8), FORE( 8), BACK(13), FORE( 8) + END,
  BACK( 8), FORE( 9), BACK(11), FORE( 8) + END,
  BACK( 9), FORE(10), BACK( 7), FORE(10) + END,
  BACK( 9), FORE(26) + END,
  BACK(10), FORE(24) + END,
  BACK(11), FORE(22) + END,
  BACK(13), FORE(19) + END,
  BACK(14), FORE(16) + END,
  BACK(17), FORE(10) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'V'
  BACK(10), FORE( 8), BACK(11), FORE( 6) + END,
  BACK(11), FORE( 7), BACK(10), FORE( 7) + END,
  BACK(11), FORE( 7), BACK(10), FORE( 7) + END,
  BACK(11), FORE( 8), BACK( 9), FORE( 6) + END,
  BACK(12), FORE( 7), BACK( 8), FORE( 7) + END,
  BACK(12), FORE( 7), BACK( 8), FORE( 7) + END,
  BACK(12), FORE( 8), BACK( 7), FORE( 6) + END,
  BACK(13), FORE( 7), BACK( 6), FORE( 7) + END,
  BACK(13), FORE( 7), BACK( 6), FORE( 7) + END,
  BACK(13), FORE( 8), BACK( 5), FORE( 6) + END,
  BACK(14), FORE( 7), BACK( 5), FORE( 6) + END,
  BACK(14), FORE( 7), BACK( 4), FORE( 7) + END,
  BACK(14), FORE( 7), BACK( 4), FORE( 6) + END,
  BACK(15), FORE( 7), BACK( 3), FORE( 6) + END,
  BACK(15), FORE( 7), BACK( 2), FORE( 7) + END,
  BACK(15), FORE( 7), BACK( 2), FORE( 6) + END,
  BACK(16), FORE( 7), BACK( 1), FORE( 6) + END,
  BACK(16), FORE(14) + END,
  BACK(16), FORE(13) + END,
  BACK(17), FORE(12) + END,
  BACK(17), FORE(12) + END,
  BACK(17), FORE(11) + END,
  BACK(18), FORE(10) + END,
  BACK(18), FORE(10) + END,
  BACK(18), FORE( 9) + END,
  BACK(19), FORE( 8) + END,
  BACK(19), FORE( 8) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  // 'W'
  BACK( 4), FORE( 7), BACK( 7), FORE(11), BACK( 7), FORE( 6) + END,
  BACK( 4), FORE( 7), BACK( 6), FORE(12), BACK( 7), FORE( 6) + END,
  BACK( 4), FORE( 7), BACK( 6), FORE(12), BACK( 7), FORE( 6) + END,
  BACK( 4), FORE( 7), BACK( 6), FORE( 5), BACK( 1), FORE( 7), BACK( 5), FORE( 6) + END,
  BACK( 4), FORE( 7), BACK( 5), FORE( 6), BACK( 2), FORE( 6), BACK( 5), FORE( 6) + END,
  BACK( 5), FORE( 6), BACK( 5), FORE( 6), BACK( 2), FORE( 7), BACK( 4), FORE( 6) + END,
  BACK( 5), FORE( 6), BACK( 5), FORE( 5), BACK( 3), FORE( 7), BACK( 4), FORE( 6) + END,
  BACK( 5), FORE( 6), BACK( 4), FORE( 6), BACK( 4), FORE( 6), BACK( 4), FORE( 6) + END,
  BACK( 5), FORE( 6), BACK( 4), FORE( 5), BACK( 5), FORE( 7), BACK( 3), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK( 2), FORE( 6), BACK( 6), FORE( 6), BACK( 3), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK( 2), FORE( 6), BACK( 6), FORE( 6), BACK( 3), FORE( 6) + END,
  BACK( 5), FORE( 7), BACK( 2), FORE( 5), BACK( 7), FORE( 7), BACK( 2), FORE( 5) + END,
  BACK( 5), FORE( 7), BACK( 1), FORE( 6), BACK( 8), FORE( 6), BACK( 1), FORE( 6) + END,
  BACK( 6), FORE( 6), BACK( 1), FORE( 5), BACK( 9), FORE(13) + END,
  BACK( 6), FORE( 6), BACK( 1), FORE( 5), BACK( 9), FORE(13) + END,
  BACK( 6), FORE(12), BACK(10), FORE(12) + END,
  BACK( 6), FORE(11), BACK(11), FORE(12) + END,
  BACK( 6), FORE(11), BACK(12), FORE(11) + END,
  BACK( 6), FORE(11), BACK(12), FORE(11) + END,
  BACK( 6), FORE(10), BACK(13), FORE(10) + END,
  BACK( 6), FORE(10), BACK(14), FORE( 9) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 9) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(17), FORE( 8) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK( 7), FORE( 7), BACK(18), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  /* 'X'
  BACK(18), FORE(10) + END,
  BACK(17), FORE(12) + END,
  BACK(17), FORE(12) + END,
  BACK(16), FORE(14) + END,
  BACK(16), FORE(15) + END,
  BACK(15), FORE( 7), BACK( 2), FORE( 7) + END,
  BACK(14), FORE( 8), BACK( 2), FORE( 8) + END,
  BACK(14), FORE( 7), BACK( 4), FORE( 7) + END,
  BACK(13), FORE( 8), BACK( 4), FORE( 8) + END,
  BACK(12), FORE( 8), BACK( 6), FORE( 8) + END,
  BACK(12), FORE( 7), BACK( 7), FORE( 8) + END,
  BACK(11), FORE( 8), BACK( 8), FORE( 8) + END,
  BACK(11), FORE( 7), BACK(10), FORE( 8) + END,
  BACK(10), FORE( 8), BACK(10), FORE( 8) + END,
  BACK( 9), FORE( 8), BACK(12), FORE( 8) + END,
  BACK( 9), FORE( 8), BACK(12), FORE( 8) + END,
  BACK( 8), FORE( 8), BACK(14), FORE( 8) + END,
  BACK( 7), FORE( 8), BACK(15), FORE( 9) + END,
  BACK( 7), FORE( 8), BACK(16), FORE( 8) + END,
  BACK( 6), FORE( 8), BACK(18), FORE( 8) + END,
  BACK( 5), FORE( 9), BACK(18), FORE( 8) + END,
  BACK( 5), FORE( 8), BACK(20), FORE( 8) + END,
  BACK( 4), FORE( 8), BACK(21), FORE( 9) + END,
  BACK( 4), FORE( 8), BACK(22), FORE( 8) + END,
  BACK( 3), FORE( 8), BACK(23), FORE( 9) + END,
  BACK( 2), FORE( 9), BACK(24), FORE( 8) + END,
  BACK( 1), FORE( 9), BACK(25), FORE( 9) + END,
  BACK(46) + END,
  BACK(46) + END, */
  // 'Y'
  BACK(17), FORE(11) + END,
  BACK(17), FORE(11) + END,
  BACK(18), FORE( 9) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(19), FORE( 7) + END,
  BACK(46) + END,
  BACK(46) + END,
  BACK(46) + END,
  /* 'Z'
  BACK(17), FORE( 9) + END,
  BACK(17), FORE( 8) + END,
  BACK(16), FORE( 8) + END,
  BACK(15), FORE( 9) + END,
  BACK(15), FORE( 8) + END,
  BACK(14), FORE( 8) + END,
  BACK(13), FORE( 9) + END,
  BACK(12), FORE( 9) + END,
  BACK(12), FORE( 8) + END,
  BACK(11), FORE( 9) + END,
  BACK(10), FORE( 9) + END,
  BACK(10), FORE( 8) + END,
  BACK( 9), FORE( 9) + END,
  BACK( 8), FORE( 9) + END,
  BACK( 8), FORE( 8) + END,
  BACK( 7), FORE( 9) + END,
  BACK( 6), FORE( 9) + END,
  BACK( 6), FORE( 8) + END,
  BACK( 5), FORE( 8) + END,
  BACK( 4), FORE( 9) + END,
  BACK( 4), FORE( 8) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK( 4), FORE(38) + END,
  BACK(46) + END,
  BACK(46) + END, */
};

const word highlightColour = 0x9CF3;  // darker because it's smaller

void SmallChars::drawFrame(int x, int y, int w, int h)
{
  // frame for digit at x, y dims w & h
  int margin = 2;
  int corner = 1;
  int topGap = 3; // extra at top
  int frameX = x - margin;
  int frameY = y - margin - topGap;
  int frameW = w + 2*margin;
  int frameH = h + 2*margin + topGap;
  // make the hole
  ILI948x::Window(frameX, frameY, frameW, frameH);
  for (int row = 0; row < frameH; row++)
  {
    if (row < corner)  // top corners
    {
      int inset = corner-row;
      ILI948x::ColourWord(backgroundColour, inset);
      ILI948x::ColourByte(0x00, frameW-2*inset);
      ILI948x::ColourWord(backgroundColour, inset);
    }
    else if (row >= frameH - 1 - corner)  // bottom corners and highlight
    {
      int inset = row - (frameH - 1 - corner);
      ILI948x::ColourWord(backgroundColour, inset);
      ILI948x::ColourWord(highlightColour, 1); 
      if (row == frameH - 1)
        ILI948x::ColourWord(highlightColour, frameW-2*inset-2); 
      else
        ILI948x::ColourByte(0x00, frameW-2*inset-2);
      ILI948x::ColourWord(highlightColour, 1); 
      ILI948x::ColourWord(backgroundColour, inset);
    }
    else
    {
      ILI948x::ColourByte(0x00, frameW);
    }
  }
  
  // detail at top of digit
  ILI948x::Window(x, y - topGap, w, topGap);
  ILI948x::ColourWord(backgroundColour, 1);
  ILI948x::ColourWord(highlightColour, w - 2);
  ILI948x::ColourWord(backgroundColour, 1);
  ILI948x::ColourWord(backgroundColour, w*(topGap-1));

  // hinges?
  int hingeH = 10;
  int hingeGapX = 0;
  int hingeW = margin - 2*hingeGapX;
  for (int side = 0; side <2; side++)
  {
    ILI948x::Window(side==0?frameX + hingeGapX:frameX + frameW - margin + hingeGapX, y + (h - hingeH)/2, hingeW, hingeH);
    for (int row = 0; row < hingeH; row++)
    {
      int highlightRow = abs(row - hingeH/4);
      if (highlightRow < 8)
        ILI948x::ColourWord(ByteHSVtoRGB(0,0,190-highlightRow*25), hingeW);
      else
        ILI948x::ColourWord(backgroundColour, hingeW);
    }
  }
}

const char PROGMEM char_map[]  = "0123456789:ABCDEFGHIJLMNOPRSTUVWY\xFF"; // no KQWXZ

void SmallChars::drawChar(int x, int y, bool top, char ch, word foreground, bool reduce, bool narrow, word background)
{
  const byte* data = (top)?rowDataUpper:rowDataLower;
  if (background == 0)
    background = backgroundColour;
  // if reduce draw two of every three rows
  int numerator   = reduce?2:1;
  int denominator = reduce?3:1;
  // if narrow halve width (only works ok for some chars, eg ':')
  int factor = narrow?2:1;
  // find the char in the map
  int idx = 0;
  while (pgm_read_byte(char_map + idx) < ch)
    idx++;
  if (pgm_read_byte(char_map + idx) == ch)
  {
    // found the char, now find the data
    idx *= HalfHeight;
    while (idx)
    {
      if (pgm_read_byte(data++) & END)
        idx--;
    }

    ILI948x::Window(x, y, Width/factor, numerator*HalfHeight/denominator);
    for (int row = 0; row < HalfHeight; row++)
    {
      int remainder = Width/factor;
      bool isBackground = true;
      byte span;
      do
      {
        span = pgm_read_byte(data++);
        int count = (span & ~END)/factor;
        if ((row % denominator) < numerator)
          ILI948x::ColourWord(isBackground?background:foreground, count);
        remainder -= count;      
  
        isBackground = !isBackground;
      } while (!(span & END));
      
      if ((row % denominator) < numerator)
        ILI948x::ColourWord(background, remainder);
    }
  }
  else
  {
    ILI948x::ColourWord(background, ILI948x::Window(x, y, Width/factor, numerator*HalfHeight/denominator));
  }
}

void SmallChars::drawStr(int x, int y, const char* str, int len, word foreground, bool background)
{
  if (foreground == 0xFFFF)
    foreground = foregroundColour;
  if (len == -1)
    len = strlen(str);
  while (len)
  {
    if (background)
      drawFrame(x, y, Width, HalfHeight*2 + 4);
    drawChar(x, y, true, *str, foreground);
    drawChar(x, y + HalfHeight + 2, false, *str, foreground);
    x += Width + 7;
    str++;
    len--;
  }
}

